<?php
class ControllerPaymentTnp extends Controller {
  private $error = array();
 
  public function index() {
    $this->language->load('payment/tnp');
    $this->document->setTitle('TraknPay Payment Method Configuration');
    $this->load->model('setting/setting');
 
    if (($this->request->server['REQUEST_METHOD'] == 'POST' && $this->validate())) {
      $this->model_setting_setting->editSetting('tnp', $this->request->post);
      $this->session->data['success'] = 'Saved.';
      $this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
    }

    $this->data['heading_title'] = $this->language->get('heading_title');
    $this->data['entry_text_tnp_checkout_label'] = $this->language->get('tnp_checkout_label');
    $this->data['entry_text_tnp_api_key'] = $this->language->get('tnp_api_key');
    $this->data['entry_text_tnp_private_salt'] = $this->language->get('tnp_private_salt');
    $this->data['button_save'] = $this->language->get('text_button_save');
    $this->data['button_cancel'] = $this->language->get('text_button_cancel');
    $this->data['entry_order_status'] = $this->language->get('entry_order_status');
    $this->data['text_enabled'] = $this->language->get('text_enabled');
    $this->data['text_disabled'] = $this->language->get('text_disabled');
    $this->data['text_edit'] = $this->language->get('text_edit');
    $this->data['entry_status'] = $this->language->get('entry_status');
    $this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
    $this->data['tnp_entry_mode']=$this->language->get('tnp_entry_mode');
    $this->data['text_mode_live']=$this->language->get('text_mode_live');
    $this->data['text_mode_test']=$this->language->get('text_mode_test');


    $this->data['action'] = $this->url->link('payment/tnp', 'token=' . $this->session->data['token'], 'SSL');
    $this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');


    if (isset($this->request->post['tnp_checkout_label'])) {
      $this->data['tnp_checkout_label'] = $this->request->post['tnp_checkout_label'];
    } else {
      $this->data['tnp_checkout_label'] = $this->config->get('tnp_checkout_label');
    }

    if (isset($this->request->post['tnp_api_key'])) {
      $this->data['tnp_api_key'] = $this->request->post['tnp_api_key'];
    } else {
      $this->data['tnp_api_key'] = $this->config->get('tnp_api_key');
    }
    if (isset($this->request->post['tnp_private_salt'])) {
      $this->data['tnp_private_salt'] = $this->request->post['tnp_private_salt'];
    } else {
      $this->data['tnp_private_salt'] = $this->config->get('tnp_private_salt');
    }
    if (isset($this->error['error_api_key'])) {
      $this->data['error_api_key'] = $this->error['error_api_key'];
    } else {
      $this->data['error_api_key'] = '';
    }

    if (isset($this->error['error_private_salt'])) {
      $this->data['error_private_salt'] = $this->error['error_private_salt'];
    } else {
      $this->data['error_private_salt'] = '';
    }

    if (isset($this->request->post['tnp_status'])) {
      $this->data['tnp_status'] = $this->request->post['tnp_status'];
    } else {
      $this->data['tnp_status'] = $this->config->get('tnp_status');
    }

    if (isset($this->request->post['tnp_order_status_id'])) {
      $this->data['tnp_order_status_id'] = $this->request->post['tnp_order_status_id'];
    } else {
      $this->data['tnp_order_status_id'] = $this->config->get('tnp_order_status_id');
    }

    if (isset($this->request->post['tnp_sort_order'])) {
      $this->data['tnp_sort_order'] = $this->request->post['tnp_sort_order'];
    } else {
      $this->data['tnp_sort_order'] = $this->config->get('tnp_sort_order');
    }

    if (isset($this->request->post['tnp_mode'])) {
      $this->data['tnp_mode'] = $this->request->post['tnp_mode'];
    } else {
      $this->data['tnp_mode'] = $this->config->get('tnp_mode');
    }
 
    $this->load->model('localisation/order_status');
    $this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
    $this->template = 'payment/tnp.tpl';
            
    $this->children = array(
      'common/header',
      'common/footer'
    );
 
    $this->response->setOutput($this->render());
  }

  protected function validate() {

    if (!$this->request->post['tnp_api_key']) {
      $this->error['error_api_key'] = $this->language->get('error_api_key');
    }
    if (!$this->request->post['tnp_private_salt']) {
      $this->error['error_private_salt'] = $this->language->get('error_private_salt');
    }
    return !$this->error;
  }
}